// u_60_calculator
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_60_calculator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    multiply_integers_: TButton;
    multiply_doubles_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure multiply_integers_Click(Sender: TObject);
    procedure multiply_doubles_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple, u_c_generic_calculator;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.multiply_integers_Click(Sender: TObject);
      var l_c_integer_computer: c_computer<Integer, c_integer_calculator>;
          l_result: Integer;
      begin
        l_c_integer_computer:= c_computer<Integer, c_integer_calculator>.Create;
        try
          l_result:= l_c_integer_computer.f_do_multiply(3, 4);
          display('3* 4= '+ IntToStr(l_result));
        finally
          l_c_integer_computer.Free;
        end; // try ... except
      end; // multiply_integers_Click

    procedure TForm1.multiply_doubles_Click(Sender: TObject);
      var l_c_double_computer: c_computer<double, c_double_calculator>;
          l_result: double;
      begin
        l_c_double_computer:= c_computer<double, c_double_calculator>.Create;
        try
          l_result:= l_c_double_computer.f_do_multiply(3.4, 5.6);
          display('3.4* 5.6= '+ FloatToStr(l_result));
        finally
          l_c_double_computer.Free;
        end;
      end; //

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

